import { Application } from 'express';
import { Resource } from 'express-automatic-routes';
import { BedProvider } from '#providers/BedProvider';
import { Req, Res } from '#interfaces/IApi';
import verify, { requireAdmin } from '#middlewares/auth';
import { validateId } from '#middlewares/validators';
import { Errors } from '#interfaces/error';
import { sendSuccess } from '#utils/responseUtils';

export default (_express: Application) => {
	const bedProvider = BedProvider.getInstance();
	return <Resource>{
		delete: {
			middleware: [verify, requireAdmin, validateId],
			handler: async (req: Req, res: Res) => {
				try {
					const bed = await bedProvider.getById({ id: req.params.id! });

					if (!bed) {
						throw Errors.notFound('Bed');
					}

					const success = await bedProvider.forceDelete(req.params.id!);

					return sendSuccess(res, success);
				} catch (error) {
					return res.error(error);
				}
			},
		},
	};
};
